/*-----------------------------------------------------------------------------
[]	LogFont.cpp
[Tv]	tHgNX̎
[l]	Ȃ
[]	2002-12-12	NC		Rgt(moralog)
		2004-03-31  pnger	EMFC(moralog)
-----------------------------------------------------------------------------*/


//-----------------------------------------------------------------------------
// CN[h
//-----------------------------------------------------------------------------
#include "stdafx.h"
#include "LogFont.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


/*-----------------------------------------------------------------------------
[]	RXgN^
[@\]	CX^X̐B
[ߒl]	Ȃ
[l]	Ȃ
-----------------------------------------------------------------------------*/
CLogFont::CLogFont()
:	m_iPointSize( 12 )
,	m_bBold( FALSE )
,	m_bItalic( FALSE )
,	m_bUnderLine( FALSE )
,	m_bStrikeOut( FALSE )
,	m_nCharSet( SHIFTJIS_CHARSET )
,	m_bFontCreate( FALSE )
{
	strcpy( m_strFontName, _T("lr oSVbN") );
}


/*-----------------------------------------------------------------------------
[]	fXgN^
[@\]	CX^X̔jB
[ߒl]	Ȃ
[l]	Ȃ
-----------------------------------------------------------------------------*/
CLogFont::~CLogFont()
{
	if ( m_bFontCreate )
	{
		::DeleteObject( m_hfonText );
		m_hfonText = NULL;
		m_bFontCreate = FALSE;
	}
}


/*-----------------------------------------------------------------------------
[]	LOGFONT\̎擾
[@\]	ݒ肳ꂽ񂩂LOGFONT\̂쐬A|C^߂B
[ߒl]	LOGFONT* LOGFONT\ [-] (-)
[l]	߂|C^͈ꎞIȂ́B
-----------------------------------------------------------------------------*/
LOGFONT*	CLogFont::GetLogFont(
	HDC		hdc		// I: ΏDC [-] (-) :-
)
{
	memset( &m_tLogFont, 0x00, sizeof(LOGFONT) );

	int		iLogPixelsY = ::GetDeviceCaps( hdc, LOGPIXELSY );
	m_tLogFont.lfHeight = -MulDiv(m_iPointSize, iLogPixelsY, 72);

	strcpy( m_tLogFont.lfFaceName, m_strFontName );

	if ( m_bBold )
	{
		m_tLogFont.lfWeight = FW_BOLD;
	}
	else
	{
		m_tLogFont.lfWeight = FW_REGULAR;
	}

	if ( m_bItalic )
	{
		m_tLogFont.lfItalic = TRUE;
	}
	else
	{
		m_tLogFont.lfItalic = FALSE;
	}

	if ( m_bUnderLine )
	{
		m_tLogFont.lfUnderline = TRUE;
	}
	else
	{
		m_tLogFont.lfUnderline = FALSE;
	}

	if ( m_bStrikeOut )
	{
		m_tLogFont.lfStrikeOut = TRUE;
	}
	else
	{
		m_tLogFont.lfStrikeOut = FALSE;
	}

	m_tLogFont.lfCharSet = m_nCharSet;

	return( &m_tLogFont );
}


/*-----------------------------------------------------------------------------
[]	CFont擾
[@\]	ݒ肳ꂽ񂩂CFont쐬A|C^߂B
[ߒl]	CFont* CFont|C^ [-] (-)
[l]	߂|C^͈ꎞIȂ́B
-----------------------------------------------------------------------------*/
HFONT	CLogFont::GetFont(
	HDC		hdc		// I: ΏDC [-] (-) :-
)
{
	if ( m_bFontCreate )
	{
		::DeleteObject( m_hfonText );
	}
	m_hfonText = ::CreateFontIndirect( GetLogFont( hdc ) );
	m_bFontCreate = TRUE;

	return( m_hfonText );
}


/*-----------------------------------------------------------------------------
[]	l
[@\]	l̃Rs[B
[ߒl]	BOOL  [-] (TRUE:AFALSE:s)
[l]	Ȃ
-----------------------------------------------------------------------------*/
BOOL CLogFont::Copy(
	const CLogFont&	fontSrc
)
{
	m_iPointSize = fontSrc.m_iPointSize;
	strcpy( m_strFontName, fontSrc.m_strFontName );
	m_bBold = fontSrc.m_bBold;
	m_bItalic =	fontSrc.m_bItalic;
	m_bUnderLine = fontSrc.m_bUnderLine;
	m_bStrikeOut = fontSrc.m_bStrikeOut;
	m_nCharSet = fontSrc.m_nCharSet;

	return( TRUE );
}