/*-----------------------------------------------------------------------------
[]	pngercore.cpp
[Tv]	PNG֐̎
[l]	ICłď̊j𕪗
[]	2004-03-30	NC		VK쐬(moralog)
		2004-04-04 online	֐I/FύX(moralog)
-----------------------------------------------------------------------------*/

//-----------------------------------------------------------------------------
// CN[h
//-----------------------------------------------------------------------------
#include "stdafx.h"
#define PNGERCORE
#include "pngercore.h"
#include "savepng.h"
#include "Unicoder.h"


/*-----------------------------------------------------------------------------
[]	NX
[pr]	s\镶p[cB
[l]	CWordToken ŊǗB
		Shift-JisUnicodeÂꂩ̏B
		m_strShiftJis != NULL łShift-JisA
		m_strShiftJis == NULL łUnicodȅB
-----------------------------------------------------------------------------*/
class CWordToken
{
public:
	CWordToken();
	virtual ~CWordToken();

	// ShiftJisݒ
	void SetShiftJis(
		LPCTSTR strSrc,
		long	iLength
	);

	// Unicodeݒ
	void SetUnicode(
		wchar_t uiUnicode
	);

	// Shift-Jis擾
	LPCTSTR	GetShiftJis(){ return( m_strShiftJis ); }

	// Unicode擾
	wchar_t	GetUnicode(){ return( m_uiUnicode ); }

	// ̗vfiXg\pj
	CWordToken*	m_pNext;

public:
	char*		m_strShiftJis;	// Shift-Jis
	wchar_t		m_uiUnicode;	// Unicode
};

// RXgN^
CWordToken::CWordToken()
: m_pNext( NULL )
, m_strShiftJis( NULL )
, m_uiUnicode( 0x00 )
{
}

// fXgN^
CWordToken::~CWordToken()
{
	if ( m_strShiftJis != NULL )
	{
		delete m_strShiftJis;
		m_strShiftJis = NULL;
	}
}

// Shift-Jisݒ
void CWordToken::SetShiftJis(
	LPCTSTR	strSrc,
	long	iLength
)
{
	if ( m_strShiftJis != NULL )
	{
		delete m_strShiftJis;
		m_strShiftJis = NULL;
	}

	if ( iLength > 0 )
	{
		m_strShiftJis = new char[ iLength+1 ];
		memcpy( m_strShiftJis, strSrc, iLength );
		m_strShiftJis[ iLength ] = 0x00;
	}
}

// Unicodeݒ
void CWordToken::SetUnicode(
	wchar_t		uiUnicode
)
{
	m_uiUnicode = uiUnicode;
}


/*-----------------------------------------------------------------------------
[]	sNX
[pr]	p[c̃Xgōs\B
[l]	CWordToken ̃XgB
		m_Head ͗vfƂĈȂB
		Xg̍ŏ̗vf m_Head.m_pNext B
-----------------------------------------------------------------------------*/
class CWordTokenList
{
public:
	CWordTokenList();
	virtual ~CWordTokenList();

	// Shift-Jisp[c̒ǉ
	void AddItem(
		LPCTSTR strSrc,
		long	iLength
	);

	// Unicodep[c̒ǉ
	void AddItem(
		wchar_t uiUnicode
	);

	// ACe擾
	int		GetCount(){ return( m_nItem ); };
 
	// Xg̐擪擾
	CWordToken*	GetHead(){ return( &m_Head ); };

public:
	CWordToken	m_Head;		// Xg̐擪
	CWordToken*	m_pTail;	// Xg̖
	int			m_nItem;
};

// RXgN^
CWordTokenList::CWordTokenList()
: m_Head()
, m_pTail( NULL )
, m_nItem( 0 )
{
	m_pTail = &m_Head;
}

// fXgN^
CWordTokenList::~CWordTokenList()
{
	CWordToken*	pItem = m_Head.m_pNext;
	while( pItem != NULL )
	{
		CWordToken*	pNext = pItem->m_pNext;
		delete pItem;
		pItem = pNext;
	}
}

// Shift-Jisp[c̒ǉ
void CWordTokenList::AddItem(
	LPCTSTR strSrc,
	long	iLength
){
	CWordToken*	pNewItem = new CWordToken;
	m_pTail->m_pNext = pNewItem;
	m_pTail = pNewItem;

	pNewItem->SetShiftJis( strSrc, iLength );
	m_nItem++;
}

// Unicodep[c̒ǉ
void CWordTokenList::AddItem(
	wchar_t uiUnicode
)
{
	CWordToken*	pNewItem = new CWordToken;
	m_pTail->m_pNext = pNewItem;
	m_pTail = pNewItem;

	pNewItem->SetUnicode( uiUnicode );
	m_nItem++;
}


//-----------------------------------------------------------------------------
// 萔
//-----------------------------------------------------------------------------
const int	LINE_HEIGHT = 18;		// s [pixel]
const int	MAX_LINE_COUNT = 50;	// ős [s]
const int	MAX_WIDTH = 1024;		// ő啝 [pixel]
 int	LEFT_MARGINE = 8;		// }[W [pixel]
 int	RIGHT_MARGINE = 8;		// }[W [pixel]
 int	TOP_MARGINE = 8;		// }[W [pixel]
 int	BOTTOM_MARGINE = 8;		// }[W [pixel]


/*-----------------------------------------------------------------------------
[]	`Kv̈擾
[@\]	AA̕`ɕKvȕ擾B
[ߒl]	int		-	`̈扡 [pixel] (-)
[l]	ߒl̓}[W܂܂ȂB
		ߒl͍ő MAX_WIDTH ɐB
-----------------------------------------------------------------------------*/
int		GetWidth(
	HDC						hdc,			// <I> `ΏDC [-] (-) :-
	CWordTokenList*			pWordTokenList,	// <I> sz  [-] (-) :-
	int						nLine			// <I> s  [-] (-) :-
)
{
	int		iMaxWidth( 0 );
	long	idxLine;
	int		iOffset( 0 );
	// sƂɕ擾Aő啝𓾂
	for ( idxLine=0 ; idxLine<nLine ; idxLine++ )
	{
		CWordToken*	pLine = pWordTokenList[idxLine].GetHead()->m_pNext;
		long			iWidth(0);

		while( pLine != NULL )
		{
			// s̕`Kv`擾
			SIZE		sizeLineExtent;
			if ( pLine->GetShiftJis() != NULL )
			{
				::GetTextExtentPoint32(
					hdc,
					pLine->GetShiftJis(),
					strlen( pLine->GetShiftJis() ),
					&sizeLineExtent
				);
			}
			else
			{
				CUnicoder*	pUnicoder = CUnicoder::GetInstance();
				sizeLineExtent = pUnicoder->ExtextCharCode(
					hdc,
					pLine->GetUnicode()
				);
			}
			iWidth += sizeLineExtent.cx;
			pLine = pLine->m_pNext;
		}
		iMaxWidth = max( iMaxWidth, iWidth );
	}
	iMaxWidth = ( (iMaxWidth+3)/4 )*4;
	return( min( MAX_WIDTH, iMaxWidth ) );
}


/*-----------------------------------------------------------------------------
[]	񕪉
[@\]	̕uāAsƂɕB
[ߒl]	int		-	s [-] (-)
[l]	ShiftJis  aDstLine ɒ~ĕ CWordTokenList ɓo^B
		Unicode ͈ꕶo^B
		łg[ŃACWordTokenɓ˂ޕ̂ƁB
-----------------------------------------------------------------------------*/
int	DevideHtml(
	const LPCTSTR		pSrc,			// <I> AAS̕  [-] (-) :-
	CWordTokenList*		pWordTokenList,	// <O> sz  [-] (-) :-
	const BOOL			bLf,
	const BOOL			bSpace
)
{
	const	iMaxLineColumn = 1024;			// ShiftJisig[Njő咷
	long	idxDst( 0 );					// ShiftJis傫
	char	aDstLine[ iMaxLineColumn ];		// Shiftjis
	long	idxSrc( 0 );
	long	idxLine( 0 );

	// 
	BOOL	bContinue = TRUE;
	while( bContinue )
	{
		// ShiftJis񂪒Ȃ肷悤KɃg[N؂
		if ( idxDst > iMaxLineColumn-HTMLCHARCODE_LENGTH )
		{
			pWordTokenList[ idxLine ].AddItem( aDstLine, idxDst );
			idxDst = 0;
		}

		// 팟
		switch( pSrc[ idxSrc ] )
		{
		case 0x00:	
			{
				bContinue = FALSE;
				if ( idxDst > 0 )
				{
					pWordTokenList[ idxLine ].AddItem( aDstLine, idxDst );
					idxDst = 0;
				}
				if ( pWordTokenList[ idxLine ].GetCount() > 0 )
				{
					idxLine++;
				}
			}
			break;

		case 0x0A:
			if ( bLf )
			{
				// s̊
				if ( idxDst > 0 )
				{
					pWordTokenList[ idxLine ].AddItem( aDstLine, idxDst );
					idxDst = 0;
				}

				idxSrc ++;
				idxLine++;
				if ( idxLine >= MAX_LINE_COUNT )
				{
					bContinue = FALSE;
				}
				break;
			}
			// s
		case 0x0D:
			// s̕Њꂾ
		case '\t':
			// ^u
			idxSrc++;
			break;

		case '<':
			// ^O̊Jn
			{
				// '<'
				if ( pSrc[ idxSrc+1 ] == 'b' || pSrc[ idxSrc+1 ] == 'B' )
				if ( pSrc[ idxSrc+2 ] == 'r' || pSrc[ idxSrc+2 ] == 'R' )
				if ( pSrc[ idxSrc+3 ] == '>' )
				{
					// s̊
					if ( idxDst > 0 )
					{
						pWordTokenList[ idxLine ].AddItem( aDstLine, idxDst );
						idxDst = 0;
					}

					idxSrc += 4;
					idxLine++;
					if ( idxLine >= MAX_LINE_COUNT )
					{
						bContinue = FALSE;
					}
					break;
				}

				// Ή'>'܂ŃXLbv
				while( pSrc[ idxSrc ] != 0x00 )
				{
					if ( pSrc[ idxSrc ] == '>' )
					{
						idxSrc++;
						break;
					}
					if ( isleadbyte( pSrc[ idxSrc ] ) )
					{
						// QoCgΉ
						idxSrc++;
					}
					idxSrc++;
				}
			}
			break;

		case '&':
			// HTML
			{
				wchar_t wchar;
				CUnicoder*	pUnicoder = CUnicoder::GetInstance();
				long	nColumn = pUnicoder->IsUnicode(
					&pSrc[idxSrc],
					&wchar
				);
				if ( nColumn > 0 )
				{
				// HTMLłB
					// }`oCgɕϊł邩H
					int			iHTMLCharCodeLength = pUnicoder->UnicodeToSJIS(
						wchar,
						aDstLine+idxDst
					);
					if ( iHTMLCharCodeLength > 2 )
					{
						// PɂȂւ񂩂͕ϊłƂƂ
						// UnicodeƂĕ\Kv
						if ( idxDst > 0 )
						{
							pWordTokenList[ idxLine ].AddItem( aDstLine, idxDst );
							idxDst = 0;
						}
						pWordTokenList[ idxLine ].AddItem( wchar );
					}
					else
					{
						// ShiftJisɕϊł̂łShiftJisŕ\悤
						idxDst += iHTMLCharCodeLength;
					}

					idxSrc += nColumn;
					break;
				}
			}
			// HTMLłȂ
			// tc[̕ƂĔFiǂݐiݏ֐iށj


		case ' ':
			if ( bSpace )
			{
				// 擪Xy[X
				if ( idxDst == 0 )
				{
					idxSrc++;
					break;
				}

				// WXy[X
				if ( aDstLine[idxDst-1] == ' ' )
				{
					idxSrc++;
					break;
				}
			}

		default:
			// ǂݐi
			if ( isleadbyte( pSrc[ idxSrc ] ) )
			{
				// QoCgΉ
				aDstLine[idxDst++] = pSrc[idxSrc++];
				aDstLine[idxDst++] = pSrc[idxSrc++];
			}
			else
			{
				aDstLine[idxDst++] = pSrc[idxSrc++];
			}
			break;
		}
	}

	return( idxLine );
}

/*-----------------------------------------------------------------------------
[]	PNGt@C쐬
[@\]	AA`悵PNGt@CɂB
[ߒl]	BOOL	-	 [-] (TRUE:AFALSE:s)
[l]	Ȃ
-----------------------------------------------------------------------------*/
BOOL CreatePng(
	const LPCTSTR	strAA,			// <I> AA  [-] (-) :-
	FILE*			pFile,
	const COLORREF	colFore,		// <I> F [-] (-) :-
	const COLORREF	colBack,		// <I> wiF [-] (-) :-
	const BOOL		bLf,
	const int		iMargine,
	const BOOL		bSpace
)
{
	LPCTSTR	pSrc = (LPCTSTR)strAA;
	LEFT_MARGINE = iMargine;
	RIGHT_MARGINE = iMargine;
	TOP_MARGINE = iMargine;
	BOTTOM_MARGINE = iMargine;

	// PNGZ[uRGBRBtɂȂĂ܂悤HH
	COLORREF	colForeBGR;
	{
		BYTE r = (BYTE)(colFore / 0x10000);
		BYTE g = (BYTE)((colFore / 0x100)%0x100);
		BYTE b = (BYTE)(colFore % 0x100);
		colForeBGR = b*0x10000 + g*0x100 + r;
	}
	COLORREF	colBackBGR;
	{
		BYTE r = (BYTE)(colBack / 0x10000);
		BYTE g = (BYTE)((colBack / 0x100)%0x100);
		BYTE b = (BYTE)(colBack % 0x100);
		colBackBGR = b*0x10000 + g*0x100 + r;
	}

	HDC		hdc = ::GetDC( NULL );
	{
		HDC hdcMem = ::CreateCompatibleDC( hdc );

		// MS PSVbN12ptŕ`
		HFONT	hfont = ::CreateFont(
			-MulDiv(12, ::GetDeviceCaps( hdc, LOGPIXELSY ), 72),
			0,
			0,0,
			FW_MEDIUM,
			0,0,0,
			SHIFTJIS_CHARSET,
			OUT_DEFAULT_PRECIS,
			DEFAULT_QUALITY,
			DEFAULT_PITCH,
			FF_DONTCARE,
			"lr oSVbN"
		);
		HFONT	hOldFont = (HFONT)::SelectObject( hdcMem, hfont );
		::SetTextColor( hdcMem, colForeBGR );

		{
			CWordTokenList		aWordTokenList[ MAX_LINE_COUNT+1 ];
			{
				// s𕪊
				int	nLine = DevideHtml(
					pSrc,
					aWordTokenList,
					bLf,
					bSpace
				);

				// `Kv̈擾
				int	iWidth = GetWidth(
					hdcMem,
					aWordTokenList,
					nLine
				);
				int iHeight = LINE_HEIGHT * nLine;

				// Kv̈̑傫̃rbg}bv쐬
				HBITMAP hbmp = ::CreateCompatibleBitmap(
					hdc,
					iWidth+LEFT_MARGINE+RIGHT_MARGINE,
					iHeight+TOP_MARGINE+BOTTOM_MARGINE
				);

				HBITMAP	hOldBmp = (HBITMAP)(::SelectObject( hdcMem, hbmp ));

				// hԂ
				{
					HBRUSH	hbr = ::CreateSolidBrush( colBackBGR );
					RECT	rc;
					rc.left = 0;
					rc.top = 0;
					rc.right = iWidth+LEFT_MARGINE+RIGHT_MARGINE+1;
					rc.bottom = iHeight+TOP_MARGINE+BOTTOM_MARGINE+1;
					::FillRect(
						hdcMem,
						&rc,
						hbr
					);
					::DeleteObject( hbr );

					// wiFݒ
					::SetBkColor( hdcMem, colBackBGR );
				}

				long	idxLine;
				long	iOffset(0);
				for( idxLine=0 ; idxLine<nLine ; idxLine++ )
				{
					long	x = 0;

					// ̕`
					CWordToken*	pToken = aWordTokenList[idxLine].GetHead()->m_pNext;
					while( pToken != NULL )
					{
						if ( pToken->GetShiftJis() != NULL )
						{
							::TextOut(
								hdcMem,
								x + LEFT_MARGINE,
								TOP_MARGINE + idxLine*LINE_HEIGHT,
								pToken->GetShiftJis(),
								strlen( pToken->GetShiftJis() )
							);

							// s̕`Kv`擾
							SIZE	sizeLineExtent;
							::GetTextExtentPoint32(
								hdcMem,
								pToken->GetShiftJis(),
								strlen( pToken->GetShiftJis() ),
								&sizeLineExtent
							);
							x += sizeLineExtent.cx;
						}
						else
						{
							CUnicoder*	pUnicoder = CUnicoder::GetInstance();

							// s̕`Kv`擾
							SIZE	sizeLineExtent;
							sizeLineExtent = pUnicoder->ExtextCharCode(
								hdcMem,
								pToken->GetUnicode()
							);
							RECT	rc;
							rc.left = x + LEFT_MARGINE;
							rc.top = TOP_MARGINE + idxLine*LINE_HEIGHT;
							rc.right = x + LEFT_MARGINE + sizeLineExtent.cx;
							rc.bottom = TOP_MARGINE + idxLine*LINE_HEIGHT + sizeLineExtent.cy;
							pUnicoder->DrawCharCode(
								hdcMem,
								rc,
								pToken->GetUnicode()
							);

							x += sizeLineExtent.cx;
						}

						pToken = pToken->m_pNext;
					}
				}

				// PNGo
				if ( pFile != NULL )
				{
					SavePng( hbmp, pFile );
					fclose( pFile );
				}

				::SelectObject( hdcMem, hOldBmp );
				::DeleteObject( hbmp );
			}
		}

		::SelectObject( hdcMem, hOldFont );
		::DeleteObject( hfont );

		::DeleteDC( hdcMem );
	}
	::ReleaseDC( NULL, hdc );

	return( TRUE );
}
